    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------------
    028     * KeyedValueComparatorType.java
    029     * -----------------------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 05-Mar-2003 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.data;
    042
    043
    044    /**
    045     * Used to indicate the type of a {@link KeyedValueComparator} : 'by key' or
    046     * 'by value'.
    047     */
    048    public final class KeyedValueComparatorType {
    049
    050        /** An object representing 'by key' sorting. */
    051        public static final KeyedValueComparatorType BY_KEY
    052            = new KeyedValueComparatorType("KeyedValueComparatorType.BY_KEY");
    053
    054        /** An object representing 'by value' sorting. */
    055        public static final KeyedValueComparatorType BY_VALUE
    056            = new KeyedValueComparatorType("KeyedValueComparatorType.BY_VALUE");
    057
    058        /** The name. */
    059        private String name;
    060
    061        /**
    062         * Private constructor.
    063         *
    064         * @param name  the name.
    065         */
    066        private KeyedValueComparatorType(String name) {
    067            this.name = name;
    068        }
    069
    070        /**
    071         * Returns a string representing the object.
    072         *
    073         * @return The string.
    074         */
    075        public String toString() {
    076            return this.name;
    077        }
    078
    079        /**
    080         * Returns <code>true</code> if this object is equal to the specified
    081         * object, and <code>false</code> otherwise.
    082         *
    083         * @param o  the other object.
    084         *
    085         * @return A boolean.
    086         */
    087        public boolean equals(Object o) {
    088            if (this == o) {
    089                return true;
    090            }
    091            if (!(o instanceof KeyedValueComparatorType)) {
    092                return false;
    093            }
    094
    095            KeyedValueComparatorType type = (KeyedValueComparatorType) o;
    096            if (!this.name.equals(type.name)) {
    097                return false;
    098            }
    099
    100            return true;
    101        }
    102
    103        /**
    104         * Returns a hash code.
    105         *
    106         * @return A hash code.
    107         */
    108        public int hashCode() {
    109            return this.name.hashCode();
    110        }
    111    }
    112